-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassMeshManager.chs

-- 

module HGamer3D.Bindings.Ogre.ClassMeshManager where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.Ogre.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}
import HGamer3D.Bindings.Ogre.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}
import HGamer3D.Bindings.Ogre.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | 
new :: IO (HG3DClass)
 -- ^ 
new =
  alloca $ \a1' -> 
  new'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 47 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | 
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 51 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading. 
setPrepareAllMeshesForShadowVolumes :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ enable
  ->  IO ()
 -- ^ 
setPrepareAllMeshesForShadowVolumes a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setPrepareAllMeshesForShadowVolumes'_ a1' a2' >>= \res ->
  return ()
{-# LINE 56 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | Retrieves whether all Meshes should prepare themselves for shadow volumes. 
getPrepareAllMeshesForShadowVolumes :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ 
getPrepareAllMeshesForShadowVolumes a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getPrepareAllMeshesForShadowVolumes'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 61 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | Gets the factor by which the bounding box of an entity is padded. Default is 0.01 
getBoundsPaddingFactor :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ 
getBoundsPaddingFactor a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getBoundsPaddingFactor'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 66 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | Sets the factor by which the bounding box of an entity is padded 
setBoundsPaddingFactor :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ paddingFactor
  ->  IO ()
 -- ^ 
setBoundsPaddingFactor a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setBoundsPaddingFactor'_ a1' a2' >>= \res ->
  return ()
{-# LINE 71 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | ManualResourceLoader::loadResource
loadResource :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  HG3DClass  -- ^ res
  ->  IO ()
 -- ^ 
loadResource a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  withHG3DClass a2 $ \a2' -> 
  loadResource'_ a1' a2' >>= \res ->
  return ()
{-# LINE 76 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | Override standard Singleton retrieval.
--Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. 
getSingleton :: IO (HG3DClass)
 -- ^ 
getSingleton =
  alloca $ \a1' -> 
  getSingleton'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 80 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}

-- | Override standard Singleton retrieval.
--Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. 
getSingletonPtr :: IO (HG3DClass)
 -- ^ 
getSingletonPtr =
  alloca $ \a1' -> 
  getSingletonPtr'_ a1' >>= \res ->
  peek  a1'>>= \a1'' -> 
  return (a1'')
{-# LINE 84 ".\\HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_construct"
  new'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_setPrepareAllMeshesForShadowVolumes"
  setPrepareAllMeshesForShadowVolumes'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_getPrepareAllMeshesForShadowVolumes"
  getPrepareAllMeshesForShadowVolumes'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_getBoundsPaddingFactor"
  getBoundsPaddingFactor'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_setBoundsPaddingFactor"
  setBoundsPaddingFactor'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_loadResource"
  loadResource'_ :: ((HG3DClassPtr) -> ((HG3DClassPtr) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_getSingleton"
  getSingleton'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\Ogre\\ClassMeshManager.chs.h ogre_mshmgr_getSingletonPtr"
  getSingletonPtr'_ :: ((HG3DClassPtr) -> (IO ()))
